package org.loom.annotation;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Tags an event that should be called just once.
 * A Single Use Token event method will decorate any link or form pointing to it, 
 * adding a parameter that is required to execute the method and will be generated 
 * when the link or form gets rendered.
 * @author icoloma
 *
 */
@Retention(RetentionPolicy.RUNTIME)
@Target({ElementType.METHOD})
@Documented
public @interface SingleUseToken {

}
