package org.loom.config;

import java.util.Collection;
import java.util.List;

import org.springframework.core.io.Resource;

/**
 * Gets notified when a Resource has been modified
 * @author icoloma
 *
 */
public interface ResourcesModificationListener {

	/** 
	 * Retrieve the list of monitorized resources
	 */
	public Collection<Resource> getResources();
	
	/**
	 * Gets notified when a Resource has been modified. Only resourcesa affecting to this listener will be passed.
	 */
	public void resourcesModified(List<Resource> resources);
	
}
