package org.loom.exception;

/**
 * This is a interface that should be implemented by exceptions that can be associated to
 * a http error, for example http 404 for "not found" errors.
 * 
 * @author icoloma
 *
 */
public interface HttpThrowable {

	/**
	 * @return the HTTP error code that should be returned to the browser for this error.
	 */
	public int getHttpError();
	
    public Throwable getCause();

}
