/*
 * Copyright 2002-2006 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.loom.interceptor;

import org.loom.mapping.ParsedAction;
import org.loom.resolution.Resolution;

/**
 * Gets called before action validation (validating the injected action properties)
 * This listener gets called after populate and before execute 
 * @author Ignacio Coloma
 */
public interface ValidateInterceptor extends Interceptor {

	/**
	 * @param action the action and event that is being executed
	 * @return if return value != null, stops the execution of 
	 * the workflow and return the provided resolution 
	 */
	public Resolution beforeValidate(ParsedAction action);
	
}
