package org.loom.persistence;

import javax.persistence.EntityManager;
import javax.persistence.spi.PersistenceProvider;

import org.hibernate.ejb.HibernatePersistence;
import org.springframework.orm.jpa.vendor.HibernateJpaVendorAdapter;

/**
 * This class exists only because HibernateJpaVendorAdapter does not have a setJpaDialect() method.
 * Tested against spring 2.5.5.
 * @author icoloma
 *
 */
public class HibernateExtendedJpaVendorAdapter extends HibernateJpaVendorAdapter {

	private PersistenceProvider persistenceProvider;
	
	public HibernateExtendedJpaVendorAdapter() {
		ExtendedPersistenceProvider pp = new ExtendedPersistenceProvider();
		pp.setDelegate(new HibernatePersistence());
		pp.setExtendedEntityManagerImplClass(HibernateExtendedEntityManagerImpl.class);
		persistenceProvider = pp;
	}
	
	@Override
	public Class<? extends EntityManager> getEntityManagerInterface() {
		return HibernateExtendedEntityManager.class;
	}
	
	@Override
	public PersistenceProvider getPersistenceProvider() {
		return persistenceProvider;
	}

}
