package org.loom.resolution;

import org.loom.servlet.CacheControl;

/**
 * A resolution that can be cached by the browser
 * @author icoloma
 */
public interface CacheableResolution extends Resolution {

	/**
	 * Sets the cache data to be sent to the browser
	 * @param cacheControl the cache data.
	 * @return this same instance, to allow easy chaining of invocations
	 */
	public CacheableResolution setCacheControl(CacheControl cacheControl);
	
}
