/*
 * Copyright 2002-2006 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.loom.resolution;

import java.util.Date;

import org.loom.servlet.LoomServletResponse;

/**
 * A Date http header
 * @author Ignacio Coloma
 */
public class DateHttpHeader extends HttpHeader {

	private Date value;
	
	public DateHttpHeader(String name, Date value, boolean add) {
		super(name, add);
		this.value = value;
	}

	@Override
	public void write(LoomServletResponse response) {
		if (isAdded()) {
			response.addDateHeader(getName(), value.getTime());
		} else {
			response.setDateHeader(getName(), value.getTime());
		}
	}
}
