/*
 * Copyright 2002-2006 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.loom.resolution;

import java.io.IOException;

import javax.servlet.ServletException;

import org.loom.servlet.LoomServletRequest;
import org.loom.servlet.LoomServletResponse;


/**
 * A Resolution is a class that delivers actual content to the browser.
 * @author Ignacio Coloma
 *
 */
public interface Resolution {

	/**
	 * Write the response contents
	 *  
	 * @param request the current request object
	 * @param response the current response object
	 */
	public void resolve(LoomServletRequest request, LoomServletResponse response) throws IOException, ServletException;
	
	
}
