package org.loom.resources;

import java.util.List;

import org.springframework.core.io.Resource;

public interface WebResourceBundleFactory {
	
	/**
	 * Creates a {@link WebResourceBundle}
	 * @param location the location of the main (JS/CSS) file of the bundle.
	 */
	WebResourceBundle create(String location);
	
	/**
	 * Creates a {@link WebResourceBundle}
	 * @param name the name of the bundle.
	 * @param resources the list of resources to include in this bundle. 
	 */
	WebResourceBundle create(String name, List<Resource> resources);

	/**
	 * If true, JS/CSS resources will be rendered separately and not obfuscated.
	 * Otherwise, concatenate and minify before rendering.
	 * @param development
	 */
	void setDevelopment(boolean development);
	
}
