package org.loom.resources.compressor;

import java.io.IOException;

import org.loom.exception.SyntaxError;

/**
 * A class that compresses a file (javascript or css), minifying and possibly obfuscating the code.
 * @author icoloma
 *
 */
public interface WebResourceCompressor {

	/**
	 * Compress the input contents.
	 * @param contents the file contents to be compressed
	 * @return the compressed result
	 */
	public String compress(String resourceName, String contents) throws IOException, SyntaxError;
	
}
