/*
 * Copyright 2002-2006 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.loom.servlet.names;

/**
 * Names of generated attributes that are not part of the HTML 5 spec.
 * These attributes have a "data-" prefix prepended.
 * 
 * @author icoloma
 */
public interface HtmlExtendedAttributeNames {

	/** overriden validation message, if any */
	static String MESSAGE = "message";
	
	/** true to exclude the minimum value of the range */
	static String EXCLUDE_MIN = "exclude-min";
	
	/** true to exclude the maximum value of the range */
	static String EXCLUDE_MAX = "exclude-max";

	/** the precision of a numeric field */
	static String PRECISION = "precision";

	/** the scale of a numeric field */
	static String SCALE = "scale";

	/** the minimum value of a number */
	static String MIN = "min";
	
	/** the maximum value of a number */
	static String MAX = "max";
	
	/** the minimum length of a text value */
	static String MIN_LENGTH = "minLength";

	/** if there is no surrounding label, this field will be used to display the translated field name */
	static String TRANSLATED_NAME = "translated-name";

}
