package org.loom.servlet.scope;

import javax.servlet.http.HttpServletRequest;

import org.loom.servlet.LoomServletRequest;

/**
 * Creates and retrieves the {@link FlashContext} instance
 * @author icoloma
 *
 */
public interface FlashContextFactory {

	/**
	 * Create a new Flash context for this request instance
	 */
	FlashContext create(LoomServletRequest request);
	
	/**
	 * Retrieves an existing Flash context for this request instance.
	 * @return the flash context, if any. Null otherwise.
	 */
	FlashContext retrieve(HttpServletRequest request, String flashID);

}
