package org.loom.tags.messages;

import java.util.Date;

import org.loom.util.DateUtils;
import org.tldgen.annotations.Attribute;
import org.tldgen.annotations.BodyContent;
import org.tldgen.annotations.Tag;

/**
 * Format a Date in minutes/hours/days etc, relative to today.
 * Equivalent to <a href="http://api.rubyonrails.org/classes/ActionView/Helpers/DateHelper.html#M001696">DateHelper.time_ago_in_words</a> in Ruby
 * and Date.humanized in format.js
 * @author icoloma
 *
 */
@Tag(
		bodyContent=BodyContent.SCRIPTLESS,
		example="&lt;l:formatDate value=\"${myDate}\"/>"
	)
public class FormatDateTag extends AbstractFormatTag {
	
	/** value to format */
	@Attribute(required=true)
	private Date value;

	@Override
	public String format() {
		return DateUtils.humanized(repository, value);
	}


	public void setValue(Date value) {
		this.value = value;
	}
	
}
