// $ANTLR 3.0 /home/icoloma/workspace/loom/src/antlr/DateValue.g 2008-11-10 18:28:24

package org.loom.validator.date;

import org.joda.time.Period;


import org.antlr.runtime.*;

/** 
 * Grammar for date validation expressions
 * Edited with ANTLRWorks
 * This file is edited for ANTLR 3.0, which is not compatible with 2.7,
 * but should work fine side-by-side with previous versions such as 
 * the one included with hibernate. For details, see 
 * http://osdir.com/ml/parsers.antlr-interest/2005-07/msg00004.html
 * @author Ignacio Coloma
 */
public class DateValueParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "DIGIT", "WS", "'today'", "'/'", "'+'", "'-'", "'d'", "'w'", "'m'", "'y'"
    };
    public static final int DIGIT=4;
    public static final int WS=5;
    public static final int EOF=-1;

        public DateValueParser(TokenStream input) {
            super(input);
        }
        

    public String[] getTokenNames() { return tokenNames; }
    public String getGrammarFileName() { return "/home/icoloma/workspace/loom/src/antlr/DateValue.g"; }

    
    	private DateValue dateValue = new DateValue();
    	
    	public DateValue getDateValue() { return dateValue; }
    	
    	// for error handling, see http://www.antlr.org/wiki/display/ANTLR3/Migrating+from+ANTLR+2+to+ANTLR+3
    	protected void mismatch(IntStream input, int ttype, BitSet follow) throws RecognitionException { 
    	  throw new MismatchedTokenException(ttype, input); 
    	}
    	public void recoverFromMismatchedSet(IntStream input, RecognitionException e, BitSet follow) throws RecognitionException { 
    	  throw e; 
    	}
    	



    // $ANTLR start validation
    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:59:1: validation : referralDate ( delta )? EOF ;
    public final void validation() throws RecognitionException {
        try {
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:60:4: ( referralDate ( delta )? EOF )
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:60:4: referralDate ( delta )? EOF
            {
            pushFollow(FOLLOW_referralDate_in_validation67);
            referralDate();
            _fsp--;

            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:60:17: ( delta )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( ((LA1_0>=8 && LA1_0<=9)) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:60:18: delta
                    {
                    pushFollow(FOLLOW_delta_in_validation70);
                    delta();
                    _fsp--;


                    }
                    break;

            }

            match(input,EOF,FOLLOW_EOF_in_validation74); 

            }

        }
         
        	catch (RecognitionException e) { 
        	  throw e; 
        	}
        finally {
        }
        return ;
    }
    // $ANTLR end validation

    public static class referralDate_return extends ParserRuleReturnScope {
    };

    // $ANTLR start referralDate
    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:63:1: referralDate : ( 'today' | ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT ) ) ;
    public final referralDate_return referralDate() throws RecognitionException {
        referralDate_return retval = new referralDate_return();
        retval.start = input.LT(1);

        try {
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:64:4: ( ( 'today' | ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT ) ) )
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:64:4: ( 'today' | ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT ) )
            {
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:64:4: ( 'today' | ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT ) )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==6) ) {
                alt4=1;
            }
            else if ( (LA4_0==DIGIT) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("64:4: ( 'today' | ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT ) )", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:64:5: 'today'
                    {
                    match(input,6,FOLLOW_6_in_referralDate91); 
                     dateValue.setStart(new TodayReferralDate()); 

                    }
                    break;
                case 2 :
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:4: ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT )
                    {
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:4: ( ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT )
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:6: ( DIGIT )? DIGIT '/' ( DIGIT )? DIGIT '/' DIGIT DIGIT DIGIT DIGIT
                    {
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:6: ( DIGIT )?
                    int alt2=2;
                    int LA2_0 = input.LA(1);

                    if ( (LA2_0==DIGIT) ) {
                        int LA2_1 = input.LA(2);

                        if ( (LA2_1==DIGIT) ) {
                            alt2=1;
                        }
                    }
                    switch (alt2) {
                        case 1 :
                            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:6: DIGIT
                            {
                            match(input,DIGIT,FOLLOW_DIGIT_in_referralDate101); 

                            }
                            break;

                    }

                    match(input,DIGIT,FOLLOW_DIGIT_in_referralDate104); 
                    match(input,7,FOLLOW_7_in_referralDate106); 
                    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:23: ( DIGIT )?
                    int alt3=2;
                    int LA3_0 = input.LA(1);

                    if ( (LA3_0==DIGIT) ) {
                        int LA3_1 = input.LA(2);

                        if ( (LA3_1==DIGIT) ) {
                            alt3=1;
                        }
                    }
                    switch (alt3) {
                        case 1 :
                            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:66:23: DIGIT
                            {
                            match(input,DIGIT,FOLLOW_DIGIT_in_referralDate108); 

                            }
                            break;

                    }

                    match(input,DIGIT,FOLLOW_DIGIT_in_referralDate111); 
                    match(input,7,FOLLOW_7_in_referralDate113); 
                    match(input,DIGIT,FOLLOW_DIGIT_in_referralDate115); 
                    match(input,DIGIT,FOLLOW_DIGIT_in_referralDate117); 
                    match(input,DIGIT,FOLLOW_DIGIT_in_referralDate119); 
                    match(input,DIGIT,FOLLOW_DIGIT_in_referralDate121); 

                    }

                     dateValue.setStart(new ConstantReferralDate(input.toString(retval.start,input.LT(-1)))); 

                    }
                    break;

            }


            }

            retval.stop = input.LT(-1);

        }
         
        	catch (RecognitionException e) { 
        	  throw e; 
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end referralDate

    public static class delta_return extends ParserRuleReturnScope {
    };

    // $ANTLR start delta
    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:70:1: delta : sign= ( '+' | '-' ) (number= DIGIT )+ units= ( 'd' | 'w' | 'm' | 'y' ) ;
    public final delta_return delta() throws RecognitionException {
        delta_return retval = new delta_return();
        retval.start = input.LT(1);

        Token sign=null;
        Token number=null;
        Token units=null;

        try {
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:71:4: (sign= ( '+' | '-' ) (number= DIGIT )+ units= ( 'd' | 'w' | 'm' | 'y' ) )
            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:71:4: sign= ( '+' | '-' ) (number= DIGIT )+ units= ( 'd' | 'w' | 'm' | 'y' )
            {
            sign=(Token)input.LT(1);
            if ( (input.LA(1)>=8 && input.LA(1)<=9) ) {
                input.consume();
                errorRecovery=false;
            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_delta141);    throw mse;
            }

            // /home/icoloma/workspace/loom/src/antlr/DateValue.g:71:27: (number= DIGIT )+
            int cnt5=0;
            loop5:
            do {
                int alt5=2;
                int LA5_0 = input.LA(1);

                if ( (LA5_0==DIGIT) ) {
                    alt5=1;
                }


                switch (alt5) {
            	case 1 :
            	    // /home/icoloma/workspace/loom/src/antlr/DateValue.g:71:27: number= DIGIT
            	    {
            	    number=(Token)input.LT(1);
            	    match(input,DIGIT,FOLLOW_DIGIT_in_delta151); 

            	    }
            	    break;

            	default :
            	    if ( cnt5 >= 1 ) break loop5;
                        EarlyExitException eee =
                            new EarlyExitException(5, input);
                        throw eee;
                }
                cnt5++;
            } while (true);

            units=(Token)input.LT(1);
            if ( (input.LA(1)>=10 && input.LA(1)<=13) ) {
                input.consume();
                errorRecovery=false;
            }
            else {
                MismatchedSetException mse =
                    new MismatchedSetException(null,input);
                recoverFromMismatchedSet(input,mse,FOLLOW_set_in_delta156);    throw mse;
            }

            
            		int delta = Integer.parseInt(number.getText());
            		if (sign.getText().charAt(0) == '-')
            			delta = -delta;
            		Period p;
            		switch (units.getText().charAt(0)) {
            			case 'd': p = Period.days(delta); break;
            			case 'w': p = Period.weeks(delta); break;
            			case 'm': p = Period.months(delta); break;
            			case 'y': p = Period.years(delta); break;
            			default:
            				throw new IllegalArgumentException("Unknown time unit '" + units.getText() + "' for period in expression: " + input.toString(retval.start,input.LT(-1)));
            		}
            		dateValue.setDelta(p);
            	

            }

            retval.stop = input.LT(-1);

        }
         
        	catch (RecognitionException e) { 
        	  throw e; 
        	}
        finally {
        }
        return retval;
    }
    // $ANTLR end delta


 

    public static final BitSet FOLLOW_referralDate_in_validation67 = new BitSet(new long[]{0x0000000000000300L});
    public static final BitSet FOLLOW_delta_in_validation70 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_validation74 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_6_in_referralDate91 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate101 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate104 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_7_in_referralDate106 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate108 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate111 = new BitSet(new long[]{0x0000000000000080L});
    public static final BitSet FOLLOW_7_in_referralDate113 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate115 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate117 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate119 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_referralDate121 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_set_in_delta141 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_DIGIT_in_delta151 = new BitSet(new long[]{0x0000000000003C10L});
    public static final BitSet FOLLOW_set_in_delta156 = new BitSet(new long[]{0x0000000000000002L});

}